/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015      by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_inithook.c 698 2015-08-01 15:00:08Z roi $
 */
/*******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS. 
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************/

#include <sil.h>
#include "stm32f4xx.h"

/*
 *  ץstm32f4-discoveryѡ
 */

#define HSE_STARTUP_TIMEOUT 0x0500		/* Time out for HSE start up */

/* PLL_VCO = (HSE_VALUE or HSI_VALUE / PLL_M) * PLL_N */
#define PLL_M      8
#define PLL_N      336

/* SYSCLK = PLL_VCO / PLL_P */
#define PLL_P      2

/* USB OTG FS, SDIO and RNG Clock =  PLL_VCO / PLLQ */
#define PLL_Q      7

#define PLLI2S_N   192
#define PLLI2S_R   5

#define RCC_CFGR_SW       (RCC_CFGR_SW_0 | RCC_CFGR_SW_1)
#define RCC_CFGR_SWS      (RCC_CFGR_SWS_0 | RCC_CFGR_SWS_1)

/*
 * Setup the microcontroller system
 * Initialize the Embedded Flash Interface, the PLL and update the SystemFrequency variable.
 * @param  None
 * @retval None
 */
void hardware_init_hook(void)
{
	unsigned int StartUpCounter = 0, HSEStatus = 0;

	/* Reset the RCC clock configuration to the default reset state */
	/* Set HSION bit */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_HSION);

	/* Reset CFGR register */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), 0x00000000);

	/* Reset HSEON, CSSON and PLLON bits */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & ~(RCC_CR_PLLON | RCC_CR_CSSON | RCC_CR_HSEON));

	/* Reset PLLCFGR register */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_CFGR_MCO2PRE_2 | RCC_CFGR_MCO1PRE_2
					 | RCC_CFGR_PPRE2_0 | RCC_CFGR_PPRE1_DIV2 | RCC_CFGR_HPRE_0);

	/* Reset HSEBYP bit */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & ~RCC_CR_HSEBYP);

	/* Disable all interrupts */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CIR), 0x00000000);

	/* SystemInit_ExtMemCtl(); no ExtMem */

	/* Configure the System clock source, PLL Multiplier and Divider factors, 
       AHB/APBx prescalers and Flash settings */
	/* Enable HSE */

	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_HSEON);

	/* Wait till HSE is ready and if Time out is reached exit */
	do{
		HSEStatus = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY;
		StartUpCounter++;
	}while((HSEStatus == 0) && (StartUpCounter != HSE_STARTUP_TIMEOUT));

	if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) != 0){
		/* Enable high performance mode, System frequency up to 168 MHz */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR)) | RCC_APB1ENR_PWREN);

		sil_wrw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR), sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR)) | PWR_CR_PMODE);

		/* HCLK = SYSCLK / 1*/
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_HPRE_DIV1);

		/* PCLK2 = HCLK / 2*/
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_PPRE2_DIV2);

		/* PCLK1 = HCLK / 4*/
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) | RCC_CFGR_PPRE1_DIV4);

		/* Configure the main PLL */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), PLL_M | (PLL_N << 6) | (((PLL_P >> 1) -1) << 16) |
                   (RCC_PLLCFGR_PLLSRC_HSE) | (PLL_Q << 24));

 		/* Enable the main PLL */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_PLLON);

		/* Wait till the main PLL is ready */
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0)
		{
		}

		/* Configure Flash prefetch, Instruction cache, Data cache and wait state */
		sil_wrw_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR), FLASH_ACR_ICEN |FLASH_ACR_DCEN |FLASH_ACR_LATENCY_5WS);

		/* Select the main PLL as system clock source */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & ~RCC_CFGR_SW) | RCC_CFGR_SW_PLL);

		/* Wait till the main PLL is used as system clock source */
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL)
		{
		}
	}
	else{
		/* If HSE fails to start-up, the application will have wrong clock
         configuration. User can add here some code to deal with this error */
	}

	/* PLLI2S clock used as I2S clock source */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & ~RCC_CFGR_I2SSRC);

	/* Configure PLLI2S */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLI2SCFGR), (PLLI2S_N << 6) | (PLLI2S_R << 28));

	/* Enable PLLI2S */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) | RCC_CR_PLLI2SON);

	/* Wait till PLLI2S is ready */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLI2SRDY) == 0)
	{
	}
}

